# [YARD](https://github.com/ArKuznetsov/yard) examples
[![GitHub release](https://img.shields.io/github/release/ArKuznetsov/yard.svg?style=flat-square)](https://github.com/666Bounty999/yard_examples/releases)

## Примеры по загрузке, распаковке и выгрузке 1С: *релизов конфигураций, аналитик, платформ и др.*
---
### Выгрузка Стандартных библиотек: 
| № | Ссылка на json | Полное_наименование_на_русском | Используемые обработчики | Ссылка на сайт релизов |
|:----|:----|:----|:----|:----|
| 1 | [SSL31](./libraries/SSL31.json) | Библиотека стандартных подсистем, редакция 3.1 ["3.1.2.*"] | Только загрузка | _https://releases.1c.ru/project/SSL31_ |
| 2 | [SSL31](./libraries/SSL31_2git.json) | Библиотека стандартных подсистем, редакция 3.1 ["3.1.2.*"] | Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/SSL31_ |
| 3 | [DMIL](./libraries/DMIL_2git.json) | 1С:Библиотека интеграции с 1С:Документооборотом, редакция 1.1 |Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/DMIL_ |
| 4 | [DMIL](./libraries/DMIL3_2git.json) -Новинка 2022 | 1С:Библиотека интеграции с 1С:Документооборотом, редакция 3.0 |Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/DMIL3_ |

### Выгрузка Типовых конфигураций фирмы "1С": 
| № | Ссылка на json | Полное_наименование_на_русском | Используемые обработчики | Ссылка на сайт релизов |
|:----|:----|:----|:----|:----|
| 1 | [Accounting30](./configurations/Accounting30_2git.json) | Бухгалтерия предприятия, редакция 3.0 ["3.0.*"] | Загрузка, сборка CF, выгрузка в GIT | _https://releases.1c.ru/project/Accounting30_ |
| 2 | [AccountingCorp30](./configurations/AccountingCorp30_2git.json) | Бухгалтерия предприятия КОРП, редакция 3.0 ["3.0.*"] | Загрузка, сборка CF, выгрузка в GIT | _https://releases.1c.ru/project/AccountingCorp30_ |
| 3 | [CPM31](./configurations/CPM31_2git.json) | 1С:Управление холдингом 3.1 ["3.1.*"] | Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/CorporatePerformanceManagement31_ |
| 4 | [CPM32](./configurations/CPM32_2git.json) -Новинка 2022 | 1С:Управление холдингом 3.2 ["3.2.*"] | Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/CorporatePerformanceManagement32_ |
| 5.1 | [DocFlowCorp21](./configurations/DocFlowCorp21_2git.json) - вариант 1| Документооборот КОРП, редакция 2.1 ["2.1.*"] |Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/DocMngCorp_ |
| 5.2 | [DocMngCorp](./configurations/DocMngCorp_2git.json) - вариант 2| Документооборот КОРП, редакция 2.1 ["2.1.*"] |Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/DocMngCorp_ |
| 6 | [DocMngCorp30](./configurations/DocMngCorp30_2git.json) | Документооборот КОРП, редакция 3.0 ["3.0.*"] |Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/DocMngCorp30_ |
| 7 | [Enterprise13](./configurations/Enterprise13_2git.json) | Управление производственным предприятием, редакция 1.3 ["1.3.*"] | Загрузка, сборка CF, выгрузка в GIT | _https://releases.1c.ru/project/Enterprise13_ |
| 8 | [EnterpriseERP20](./configurations/EnterpriseERP20_2git.json) | 1С:ERP Управление предприятием 2 ["2.*"] | Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/EnterpriseERP20_ |
| 9 | [HRMCorp30](./configurations/HRMCorp30_2git.json) | Зарплата и управление персоналом КОРП, редакция 3  ["3.1.*"] | Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/HRMCorp30_ |
| 10 | [HRMCorp3018](./configurations/HRMCorp3018_2git.json) -Версия длительного сопровождения 3.1.18 выгружается отдельно | Зарплата и управление персоналом КОРП, редакция 3 ["3.1.18.*"] | Используемые обработчики | _https://releases.1c.ru/project/HRMCorp30_ |
| 11 | [Trade110](./configurations/Trade110_2git.json) | Управление торговлей, редакция 11 ["11.*"] | Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/Trade110_ |
| 12 | [Trade1104](./configurations/Trade1104_2git.json) -Поддержка подредакции 11.4 велась до апреля 2022 включительно, сейчас завершена.| Управление торговлей, редакция 11 ["11.4.*"] | Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/Trade110_ |

---
### Выгрузка Технологических дистрибутивов (платформ, аналитики, конвертации данных, КИП, СППР, и др):
| № | Ссылка на json | Полное_наименование_на_русском | Используемые обработчики | Ссылка на сайт релизов |
|:----|:----|:----|:----|:----|
| 1 | [Analytics](./distributions_and_others/Analytics.json) | 1С:Аналитика. Версия 1.* Дистрибутив \\(zip\\) | Только загрузка | _https://releases.1c.ru/project/Analytics_ |
| 2 | [CollaborationSystem](./distributions_and_others/CollaborationSystem.json) | Сервер взаимодействия \\(64-bit\\) Windows | Только загрузка | _https://releases.1c.ru/project/CollaborationSystem_ |
| 3 | [Conversion30](./distributions_and_others/Conversion30_2git.json) | 1С:Конвертация данных 3 | Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/Conversion30_ |
| 4 | [EDT](./distributions_and_others/EDT.json) | Дистрибутив 1C:EDT для ОС Windows 64 бит | Только загрузка | _https://releases.1c.ru/project/DevelopmentTools10_ |
| 5 | [ETP](./distributions_and_others/ETP.json) - весь| Корпоративный инструментальный пакет 8 :  ETP | Только загрузка | _https://releases.1c.ru/project/ETP_ |
| 5.1 | [ETP TestCenter](./distributions_and_others/ETP_TestCenter.json) - отдельная выгрузка ТестЦентра из ETP | Корпоративный инструментальный пакет 8 : ETP | Только загрузка | _https://releases.1c.ru/project/ETP_ |
| 6 | [Modeling](./distributions_and_others/Modeling.json) | Система проектирования прикладных решений | Только загрузка | _https://releases.1c.ru/project/Modeling_ |
| 7 | [Mobile](./distributions_and_others/Mobile.json) | Мобильная платформа 1С:Предприятия | Только загрузка | _https://releases.1c.ru/project/mobile_ |
| 8 | [Platform83_windows](./distributions_and_others/Platform83_windows.json) | Технологическая платформа 8.3 | Только загрузка | _https://releases.1c.ru/project/Platform83_ |
| 9 | [Platform83_windows64full](./distributions_and_others/Platform83_windows64full.json) | Технологическая платформа 8.3 | Только загрузка | _https://releases.1c.ru/project/Platform83_ |

---
### Выгрузка Отраслевых решений: 
| № | Ссылка на json | Полное_наименование_на_русском | Используемые обработчики | Ссылка на сайт релизов |
|:----|:----|:----|:----|:----|
| 1 | [PMCorp](./solutions/PMCorp_2git.json) | 1С:PM Управление проектами КОРП ["1.3.*"] | Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/PMCorp_ |
| 2 | [TSZH1C30](./solutions/TSZH1C30_2git.json) | 1С-Учет в управляющих компаниях ЖКХ, ТСЖ и ЖСК, редакция 3.0 ["3.0.*"] | Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/TSZH1C30_ |
| 3 | [TOIR13](./solutions/TOIR13_2git.json) | ТОИР Управление ремонтами и обслуживанием оборудования, редакция 1.3 ["1.3.*"] | Загрузка, выгрузка в GIT | _https://releases.1c.ru/project/TOIR13_ |

В представленных примерах можно увидеть разные пути к каталогам для сохранения и распаковки.  Дело царское, дело барское, все на Ваше усмотрение.
